
#ifndef WAVELENGTH_H_INCLUDED
#define WAVELENGTH_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Returns the xbar, ybar, zbar values for a given wavelength.  The
 * wavelength must be between 360nm and 830nm inclusive.  Values are for
 * the 2-degree observer.
 */
void wavelength_to_xyz( int nm, double *x, double *y, double *z );

/**
 * Returns true if the given x,y chromanicity values are inside the XYZ
 * gamut defined by the wavelength data.  This is done using a convex
 * polygon intersection test routine.
 */
int xy_in_gamut( double x, double y );

#ifdef __cplusplus
};
#endif

#endif /* WAVELENGTH_H_INCLUDED */
