

#ifndef CAMERA_H_INCLUDED
#define CAMERA_H_INCLUDED

#include <point3.h>
#include <vector3.h>
#include <matrix4x4.h>

class Camera
{
public:
    Camera( const Point3 &pos, const Vector3 &upv, const Vector3 &fwdv,
            const double &initfov );
    ~Camera( void );

    Point3 getEye( void ) const { return eye; }
    Vector3 screenRay( double x, double y ) const;
    void transformEyePosition( const Matrix4x4 &xform );

private:
    Point3 eye;
    Vector3 up;
    Vector3 forward;
    double fov;
    Matrix4x4 viewtoworld;
    double screendist;
};

#endif // CAMERA_H_INCLUDED
