
#ifndef MATERIAL_H_INCLUDED
#define MATERIAL_H_INCLUDED

#include <string>
#include <pixelxyz.h>

class Material
{
public:
    Material( void )
        : c( PixelXYZ::black ), r( 0.0 ), t( 0.0 ) {}
    ~Material( void ) {}

    void setColour( const PixelXYZ &newc ) { c = newc; }
    void setReflectivity( const double &newr ) { r = newr; }
    void setTransmissivity( const double &newt ) { t = newt; }
    void setLuminous( const bool &newl ) { l = newl; }
    void setName( const char *name ) { matname = name; }

    const char *getName( void ) const { return matname.c_str(); }
    PixelXYZ getColour( void ) const { return c; }
    double getReflectivity( void ) const { return r; }
    double getTransmissivity( void ) const { return t; }
    bool isLuminous( void ) const { return l; }

private:
    std::string matname;
    PixelXYZ c;
    double r, t;
    bool l;
};

#endif // MATERIAL_H_INCLUDED
