
#include <utils.h>
#include <plane.h>

Plane::Plane( const Vector3 &normal )
{
    a = normal.getX();
    b = normal.getY();
    c = normal.getZ();
}

Plane::~Plane( void )
{
}

bool Plane::closestIntersect( const Point3 &planeref,
                              const Point3 &o, const Vector3 &dir,
                              double *t ) const
{
    double bot = ( (  a * dir.getX() ) + ( b * dir.getY() ) + ( c * dir.getZ() ) );
    if( threshEqual( 0.0, bot ) ) return false;

    double d = ( -a * planeref.getX() )
             - (  b * planeref.getY() )
             - (  c * planeref.getZ() );

    double top = ( ( -a * o.getX() ) - ( b * o.getY() ) - ( c * o.getZ() ) - d );
    *t = top / bot;
    if( *t < 0.0 ) return false;

    return true;
}

