
#ifndef POINT3_H_INCLUDED
#define POINT3_H_INCLUDED

#include <vector3.h>

class Point3
{
public:
    Point3( void )
        : x( 0.0 ), y( 0.0 ), z( 0.0 ) {}
    Point3( const double &xpos, const double &ypos, const double &zpos )
        : x( xpos ), y( ypos ), z( zpos ) {}
    ~Point3( void ) {}

    static Point3 origin;

    Vector3 subtract( const Point3 &right ) const
    {
        return Vector3( x - right.x, y - right.y, z - right.z );
    }

    Point3 add( const Vector3 &right ) const
    {
        return Point3( x + right.getX(), y + right.getY(), z + right.getZ() );
    }

    double getX( void ) const { return x; }
    double getY( void ) const { return y; }
    double getZ( void ) const { return z; }

private:
    double x, y, z;
};

#endif // POINT3_H_INCLUDED
