
#ifndef SCENEPARSER_H_INCLUDED
#define SCENEPARSER_H_INCLUDED

#include <stl.h>
#include <vector>
#include <fstream>
#include <material.h>
#include <camera.h>
#include <node.h>
#include <baseobject.h>

class SceneParser
{
public:
    explicit SceneParser( const char *filename );
    ~SceneParser( void );

    Node *getNode( const char *name ) const;
    Camera *getCamera( void ) const { return camera; }
    int getWidth( void ) const { return width; }
    int getHeight( void ) const { return height; }
    int getGridWidth( void ) const { return gridwidth; }

private:
    std::ifstream infile;
    vector<Material *> materials;
    vector<Node *> nodes;
    Camera *camera;
    int width, height, gridwidth;

    void parseMaterial( void );
    void parseCamera( void );
    Node *parseNode( void );
    void readTriple( double &x, double &y, double &z );
    Material *getMaterial( const char *name ) const;
};

#endif // SCENEPARSER_H_INCLUDED
