
#ifndef SHADER_H_INCLUDED
#define SHADER_H_INCLUDED

#include <scene.h>
#include <pixelxyz.h>

class Shader
{
public:
    explicit Shader( const Scene *scene );
    ~Shader( void );

    PixelXYZ shadeRay( const Point3 &origin, const Vector3 &dir ) const;
    PixelXYZ shadePoint( const Point3 &viewer,
                         const Point3 &pos, const Vector3 &norm,
                         Material *mat ) const;

    PixelXYZ pointSample( double x, double y ) const;

    PixelXYZ adaptivePoint( double x, double y, int depth,
                            double w, double h, int maxdepth ) const;
    PixelXYZ superPoint( double x, double y, int depth,
                         double w, double h, int maxdepth ) const;
    void adaptiveSampleScanline( PixelXYZ *output, int y,
                                 int w, int h, int depth ) const;
    void superSampleScanline( PixelXYZ *output, int y,
                              int w, int h, int depth ) const;
    void pointSampleScanline( PixelXYZ *output, int y, int w, int h ) const;

private:
    const Scene *s;
};

#endif // SHADER_H_INCLUDED
