
#ifndef TRIANGLE_H_INCLUDED
#define TRIANGLE_H_INCLUDED

#include <primitive.h>
#include <vertexlist.h>

class Triangle : public Primitive
{
public:
    explicit Triangle( VertexList *vlist );
    virtual ~Triangle( void );

    BoundingBox getBoundingBox( void ) const;
    PrimitiveList foldModel( const Matrix4x4 &xform ) const;

    bool closestIntersect( const Point3 &origin, const Vector3 &dir,
                           double *t, Vector3 *norm, Material **mat ) const;

private:
    Point3 ptlist[3];
    Vector3 normal;
    Vector3 edge1, edge2;
};

#endif // SPHERE_H_INCLUDED
