

#ifndef UNIFORMGRID_H_INCLUDED
#define UNIFORMGRID_H_INCLUDED

#include <list>
#include <point3.h>
#include <baseobject.h>
#include <boundingbox.h>
#include <primitive.h>
#include <plane.h>

struct GridSquare
{
    int x, y, z;
    PrimitiveList contents;
};

class UniformGrid
{
public:
    UniformGrid( int gridwidth );
    ~UniformGrid( void );

    void addPrimitive( Primitive *p );
    void printBounds( void ) const;

    bool gonFishin( const Point3 &pos ) const;
    GridSquare *getCurrentSquare( const Point3 &pos ) const;
    double getNextSquare( const Point3 &pos, const Vector3 &dir ) const;

private:
    list<GridSquare *> *squares;
    int width;
    int minx, maxx, miny, maxy, minz, maxz;
    int numprimitives;
    int populatedsquares;

    GridSquare *getSquare( int x, int y, int z );
    Plane xy, yz, zx;
};

#endif // UNIFORMGRID_H_INCLUDED
